﻿//========================================================================================
//         "Неразрывности"
//          (noBreak.jsx)
//
// Версия 1.0
var ver = "1.0"
//
//    Скрипт обрабатывает выделенный текстовый фрейм или связку,
//  находит телефоны по маске "цифра-цифра" и "Т. ", надписи типа 
//  "999 т.р.", "222 р." и устанавливает найденному 
//  атрибут "nobreak"
//
// Автор: Андрей Рыжков (ragman)
//
// Дата: 26.04.2006 г.
//
//=========================================================================================

// Устанавливаем переменные по-умолчанию
allTextFrames = false; 				// Обрабатывать цепочку связаных текстовых фреймов?
myParagraphStyleNameSelect = "ОБЪЯВЛЕНИЯ";	// Стиль параграфа
myAllParagraphStyle = true;			// Все параграфы


with (app) {
//Проверяем, что у нас выделено
	if (selection.length != 1) {
		alert("Необходимо вытелить один текстовый фрейм");
		exit();
	}
	if (selection[0].constructor.name != "TextFrame") {
		alert("Необходимо вытелить один текстовый фрейм");
		exit();
	}
	// Создаем список стилей в публикации
	var myParagraphStyleName = new Array();
	var mySelectIndexParagraphStyle = 0;
	for (myCounter = 0; myCounter < activeDocument.paragraphStyles.length; myCounter++) {
		myParagraphStyleName[myCounter] = activeDocument.paragraphStyles.item(myCounter).name;
		if (myParagraphStyleName[myCounter] == myParagraphStyleNameSelect) {
			mySelectIndexParagraphStyle = myCounter;
		}

	}
	
	// Создаем диалог
	var myDialog = dialogs.add({name:"Неразрывности " + ver});
	// Подготовка
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add().borderPanels.add().dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Обрабатывать параграфы стиля:"});
				var myDialogParagraphStyle = dropdowns.add({stringList:myParagraphStyleName, selectedIndex:mySelectIndexParagraphStyle});
				staticTexts.add({staticLabel:"или все"});
				var myDialogAllParagraphStyle = checkboxControls.add({});
				myDialogAllParagraphStyle.checkedState = myAllParagraphStyle;
			}
			with (dialogRows.add()) {
				var myDialogAllTextFrames = checkboxControls.add({});
				myDialogAllTextFrames.checkedState = allTextFrames;
				staticTexts.add({staticLabel:"Обрабатывать связанные фреймы"});
			}
		}
		with (dialogRows.add()) {
			dialogColumns.add().staticTexts.add({staticLabel:"Андрей Рыжков     special946@gmail.com"});
		}
	}
	// Показываем
	var myResult = myDialog.show();
	if (!myResult) {
		myDialog.destroy();
		exit();
	}
	
	allTextFrames = myDialogAllTextFrames.checkedState;
	myParagraphStyle = activeDocument.paragraphStyles.item(myDialogParagraphStyle.selectedIndex);
	myAllParagraphStyle = myDialogAllParagraphStyle.checkedState;	

	// Обрабатывать цепочку фреймов?
	if (allTextFrames) {
		var myStory = selection[0].parentStory;
	} else {
		var myStory = selection[0];
	}

	findPreferences = null; 
	changePreferences = null; 
	changePreferences.noBreak = true;
	myStory.search("^9-^9", false, false, "");
	myStory.search("Т. ^9", false, false, "");	
	myStory.search("^9 т.р.", false, false, "");
	myStory.search("^9 р.", false, false, "");
	findPreferences = null; 
	changePreferences = null; 

		
}